> ## Documentation Index
> Fetch the complete documentation index at: https://developer.box.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Make changes to an existing task

export const Link = ({href, children, className, ...props}) => {
  const localizedHref = localizeLink(href);
  return <a href={localizedHref} className={className} {...props}>
      {children}
    </a>;
};

export const MultiRelatedLinks = ({sections = []}) => {
  if (!sections || sections.length === 0) {
    return null;
  }
  return <div className="space-y-8">
      {sections.map((section, index) => <RelatedLinks key={index} title={section.title} items={section.items} />)}
    </div>;
};

export const RelatedLinks = ({title, items = []}) => {
  const getBadgeClass = badge => {
    if (!badge) return "badge-default";
    const badgeType = badge.toLowerCase().replace(/\s+/g, "-");
    return `badge-${badge === "ガイド" ? "guide" : badgeType}`;
  };
  if (!items || items.length === 0) {
    return null;
  }
  return <div className="my-8">
      {}
      <h3 className="text-sm font-bold uppercase tracking-wider mb-4">{title}</h3>

      {}
      <div className="flex flex-col gap-3">
        {items.map((item, index) => <a key={index} href={item.href} className="py-2 px-3 rounded related_link hover:bg-[#f2f2f2] dark:hover:bg-[#111827] flex items-center gap-3 group no-underline hover:no-underline border-b-0">
            {}
            <span className={`px-2 py-1 rounded-full text-xs font-semibold uppercase tracking-wide flex-shrink-0 ${getBadgeClass(item.badge)}`}>
              {item.badge}
            </span>

            {}
            <span className="text-base">{item.label}</span>
          </a>)}
      </div>
    </div>;
};

To update a task in Box you will need to call the
<Link href="/reference/put-tasks-id">`PUT /tasks/:task_id`</Link> API with the ID of the task. This API
can be used to change the `action` type of the task, add a `message`, or change
the due date.

<CodeGroup>
  ```sh cURL theme={null}
  curl -i -X PUT "https://api.box.com/2.0/tasks/12345" \
       -H "authorization: Bearer <ACCESS_TOKEN>" \
       -H "content-type: application/json" \
       -d '{
         "action": "review"
       }'
  ```

  ```typescript Node/TypeScript v10 theme={null}
  await client.tasks.updateTaskById(task.id!, {
    requestBody: {
      message: 'updated message',
    } satisfies UpdateTaskByIdRequestBody,
  } satisfies UpdateTaskByIdOptionalsInput);
  ```

  ```python Python v10 theme={null}
  client.tasks.update_task_by_id(task.id, message="updated message")
  ```

  ```csharp .NET v10 theme={null}
  await client.Tasks.UpdateTaskByIdAsync(taskId: NullableUtils.Unwrap(task.Id), requestBody: new UpdateTaskByIdRequestBody() { Message = "updated message" });
  ```

  ```swift Swift v10 theme={null}
  try await client.tasks.updateTaskById(taskId: task.id!, requestBody: UpdateTaskByIdRequestBody(message: "updated message"))
  ```

  ```java Java v10 theme={null}
  client.getTasks().updateTaskById(task.getId(), new UpdateTaskByIdRequestBody.Builder().message("updated message").build())
  ```

  ```java Java v5 theme={null}
  BoxTask task = new BoxTask(api, "id");
  BoxTask.Info info = task.new Info();
  info.setMessage("An edited message.");
  task.updateInfo(info);
  ```

  ```py Python v4 theme={null}
  task_update = {'message': 'New Message', 'due_at': '2014-04-03T11:09:43-10:00'}
  updated_task = client.task(task_id='12345').update_info(data=task_update)
  print(f'New task message is {updated_task.message} and the new due time is {updated_task.due_at}')
  ```

  ```csharp .NET v6 theme={null}
  var updates = new BoxTaskUpdateRequest()
  {
      Id = "22222",
      Message = "Could you please review this?"
  };
  BoxTask updatedTask = await client.TasksManager.UpdateTaskAsync(updates);
  ```

  ```js Node v4 theme={null}
  client.tasks.update('11111', { message: 'Could you please review?' })
   .then(task => {
    /* task -> {
     type: 'task',
     id: '11111',
     item: 
     { type: 'file',
      id: '22222',
      sequence_id: '0',
      etag: '0',
      sha1: '0bbd79a105c504f99573e3799756debba4c760cd',
      name: 'box-logo.png' },
     due_at: '2014-04-03T11:09:43-07:00',
     action: 'review',
     message: 'Could you please review?',
     task_assignment_collection: { total_count: 0, entries: [] },
     is_completed: false,
     created_by: 
     { type: 'user',
      id: '33333',
      name: 'Example User',
      login: 'user@example.com' },
     created_at: '2013-04-03T11:12:54-07:00' }
    */
   });
  ```
</CodeGroup>

## Task actions

Box currently supports two types of tasks defined by the `action` value:
`review` tasks and `complete` tasks.

The type of task determines the possible resolution states a task can be in and
the interface shown to a user in the web and mobile apps.

| Task action | Possible resolution states           |
| ----------- | ------------------------------------ |
| `review`    | `incomplete`, `approved`, `rejected` |
| `complete`  | `incomplete`, `complete`             |

A `review` task starts out in an `incomplete` state and can be marked as
`incomplete`, `approved`, or `rejected`. In the user interface a user is
provided with a text box and an pair of buttons to approve or reject the task.

A `complete` task starts out in an `incomplete` state and can be marked
`incomplete` or `completed`. Once a this task is marked completed, no
further changes can be made to the task's state. In the user interface a user is
provided with a text box and an button to mark the task as completed.

## Completion rules

A task on a file can be assigned to more than one collaborator on the file, and
a task has a `completion_rule` that can be used to define if all users who've
been assigned the task (`all_assignees`) or only one assignee (`any_assignee`)
need to complete the task.

<RelatedLinks
  title="RELATED APIS"
  items={[
{ label: translate("Update task"), href: "/reference/put-tasks-id", badge: "PUT" }
]}
/>

<RelatedLinks
  title="RELATED GUIDES"
  items={[
{ label: translate("Create a task"), href: "/guides/tasks/create", badge: "GUIDE" },
{ label: translate("Get information about a task"), href: "/guides/tasks/get", badge: "GUIDE" },
{ label: translate("Delete a task"), href: "/guides/tasks/delete", badge: "GUIDE" }
]}
/>
